﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;


using Microsoft.Research.Kinect.Nui;
using Microsoft.Research.Kinect.Audio;
namespace WpfDepthId
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        Runtime nui;
        public MainWindow()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            nui = Runtime.Kinects[0];
            nui.Initialize(RuntimeOptions.UseDepthAndPlayerIndex | RuntimeOptions.UseSkeletalTracking);
            nui.DepthStream.Open(ImageStreamType.Depth, 2, ImageResolution.Resolution320x240, ImageType.DepthAndPlayerIndex);
            nui.DepthFrameReady += new EventHandler<ImageFrameReadyEventArgs>(nui_DepthFrameReady);
        }
        void nui_DepthFrameReady(object sender, ImageFrameReadyEventArgs e)
        {
            PlanarImage Image = e.ImageFrame.Image;
            int[] depth = new int[Image.Width * Image.Height];
            int[] player = new int[Image.Width * Image.Height];
            int[] playercoded = new int[Image.Width * Image.Height];

            for (int i = 0; i < depth.Length; i++)
            {
                depth[i] = (Image.Bits[i * 2 + 1] << 5) | (Image.Bits[i * 2] >> 3);
                player[i] = Image.Bits[i * 2] & 0x07;
                playercoded[i] = 0;
                if ((player[i] & 0x01) == 0x01) playercoded[i] |= 0xFF0000;
                if ((player[i] & 0x02) == 0x02) playercoded[i] |= 0x00FF00;
                if ((player[i] & 0x04) == 0x04) playercoded[i] |= 0x0000FF;


            }
            image1.Source = IntToBitmap(depth, Image.Width, Image.Height);
            image2.Source = IntToBitmap(playercoded, Image.Width, Image.Height);
        }
        BitmapSource IntToBitmap(int[] array, int w, int h)
        {
            BitmapSource bmap = BitmapSource.Create(
                w,
                h,
                96, 96,
                PixelFormats.Bgr32,
                null,
                array,
                w * 4);
            return bmap;

        }
      

        private void Window_Closing(object sender, System.ComponentModel.CancelEventArgs e)
        {
            nui.Uninitialize();
            Environment.Exit(0);
        }
    }
}
